# Interface ISearchResult

All Known Implementing Classes:
  `AbstractTextSearchResult`

public interface ISearchResult
Implementors of this interface represent the result of a search. How the results of a search are structured is up to the implementor of this interface. The abstract base implementation provided with `AbstractTextSearchResult` uses a flat list of matches to represent the result of a search. Subclasses of `SearchResultEvent` can be used in order to notify listeners of search result changes.

To present search results to the user implementors of this interface must also provide an extension for the extension point `org.eclipse.search.searchResultViewPage`.

Clients may implement this interface.

Since:
  3.0
See Also:
  - `ISearchResultPage`

## Method Summary

Modifier and Type
Method
Description
`void`
`addListener(ISearchResultListener l)`
Adds a `ISearchResultListener`.
`ImageDescriptor`
`getImageDescriptor()`
Returns an image descriptor for the given ISearchResult.
`String`
`getLabel()`
Returns a user readable label for this search result.
`ISearchQuery`
`getQuery()`
Returns the query that produced this search result.
`String`
`getTooltip()`
Returns a tooltip to be used when this search result is shown in the UI.
`void`
`removeListener(ISearchResultListener l)`
Removes a `ISearchResultChangedListener`.

## Method Details

### addListener

void addListener(ISearchResultListener l)
Adds a `ISearchResultListener`. Has no effect when the listener has already been added.

Parameters:
  `l` - the listener to be added

### removeListener

void removeListener(ISearchResultListener l)
Removes a `ISearchResultChangedListener`. Has no effect when the listener hasn't previously been added.

Parameters:
  `l` - the listener to be removed

### getLabel

String getLabel()
Returns a user readable label for this search result. The label is typically used in the result view and should contain the search query string and number of matches.

Returns:
  the label for this search result

### getTooltip

String getTooltip()
Returns a tooltip to be used when this search result is shown in the UI.

Returns:
  a user readable String

### getImageDescriptor

ImageDescriptor getImageDescriptor()
Returns an image descriptor for the given ISearchResult.

Returns:
  an image representing this search result or `null`

### getQuery

ISearchQuery getQuery()
Returns the query that produced this search result.

Returns:
  the query producing this result